<%= form_with method: 'get', skip_enforcing_utf8: true, 
              local: true, class: "ui form dividing", 
              id: "report_search_form" do |form| %>
  <%= hidden_field_tag :token, @token %>
  <%= hidden_field_tag :template, request.env['PATH_INFO'] %>
  <%  assessment_or_refer = type%>

  <% if roles == 'admin'%>
    <div class="fields">
      <% if is_bma %>
        <%= hidden_field_tag :htype, @searchable.htype %>
      <% else %>
        <div class="field">
          <%= label_tag t("report.htype_label"), nil, required: true %>
          <div class="radio-group">
            <label class="radio-button">
              <%= radio_button_tag :htype, "1", @searchable.htype == 1, id: "hospital_type_rd" %>
              <span class="text">
                <%= t("report.hospital_type_label") %>
              </span>
            </label>
            <label class="radio-button">
              <%= radio_button_tag :htype, "4", @searchable.htype == 4, id: "clinic_type_rd" %>
              <span class="text">
                <%= t("report.clinic_type_label") %>
              </span>
            </label>
            <label class="radio-button">
              <%= radio_button_tag :htype, "3", @searchable.htype == 3, id: "public_health_center_type_rd" %>
              <span class="text">
                <%= t("report.public_health_center_type_label") %>
              </span>
            </label>
            <label class="radio-button">
              <%= radio_button_tag :htype, "0", @searchable.htype == 0, id: "other_type_rd" %>
              <span class="text">
                <%= t("report.other_label") %>
              </span>
            </label>
          </div>
        </div>
      <% end %>
      <div class="field hospital">
        <%= label_tag t("report.hospital_label"), nil %>
        <%= select_tag :hospital, options_for_select([[t("report.all_label"), 'all']].concat(@hospitals_select), @searchable.hospital),
                        { 
                          # prompt: t('please_select_label'), 
                          class: 'ui search dropdown hospital',
                          id: 'hospital'
                        } %>
      </div>
    </div>
  <% else %>
    <%= hidden_field_tag :hospital, @current_site.code, { 
                          prompt: t('please_select_label'), 
                          class: 'ui search dropdown hospital',
                          id: 'hospital', required: true 
                        }
    %>
  <% end %>

  <div class="fields">
    <div class="field">
      <%= label_tag t("report.date_type_label"), nil, required: true %>
      <div class="radio-group --md">
        <label class="radio-button">
          <%= radio_button_tag :date_type, assessment_or_refer, (@searchable.date_type.nil? && assessment_or_refer) || @searchable.date_type == assessment_or_refer, required: true %>
          <span class="text">
            <%= t("report.date_type_#{type}_label") %>
          </span>
        </label>
        <label class="radio-button">
          <%= radio_button_tag :date_type, "save", @searchable.date_type == "save" , required: true %>
          <span class="text">
            <%= t("report.date_type_save_label") %>
          </span>
        </label>
      </div>
    </div>
    <div class="field">
      <%= label_tag t("report.from_label"), nil, required: true %>
      <div id="from_date_component">
        <div class="ui input left icon">
          <i class="calendar icon"></i>
          <%= text_field_tag 'from_date', nil, placeholder: t('report.date_label'), required: true, autocomplete: 'off' %>
        </div>
      </div>
    </div>
    <div class="field">
      <%= label_tag t("report.to_label"), nil, required: true %>
      <div id="to_date_component">
        <div class="ui input left icon">
          <i class="calendar icon"></i>
          <%= text_field_tag 'to_date', nil, placeholder: t('report.date_label'), required: true, autocomplete: 'off' %>
        </div>
      </div>
    </div>
  </div>

  <div class="fields">
    <div class="field">
      <%= label_tag t("report.destination_label"), nil, required: true %>
      <div class="radio-group --md">
        <label class="radio-button">
          <%= radio_button_tag :destination, 'accept', (@searchable.destination.nil? && 'accept') || @searchable.destination == 'accept', required: true %>
          <span class="text">
            <%= t("report.destination_accept") %>
          </span>
        </label>
        <label class="radio-button">
          <%= radio_button_tag :destination, "site", @searchable.destination == 'site', required: true %>
          <span class="text">
            <%= t("report.destination_site_label") %>
          </span>
        </label>
      </div>
    </div>
   
    <div class="field hospital_destination <%= display_hospitals = @searchable.destination == 'site' ? "" : "disabled"%>" id="hospital_destination_select">
      <%= label_tag t("report.destination_site_label"), nil %>
      <%= select_tag :hospital_destination, options_for_select([[t("report.all_label"), 'all']].concat(Hospital.all.map { |h| [h.label, h.code] }), @searchable.hospital_destination ),
                      { 
                        class: 'ui search dropdown hospital',
                        id: 'hospital_destination'
                      } %>
    </div>
  </div>

  <div class="fields">
    <div class="field case_manager_dropdown" id="case_manager_dropdown_field">
      <%= label_tag t("report.case_manager_#{type}_label") %>
      <%= select_tag :case_manager, options_for_select([[t("report.all_label"), 'all']].concat(@providers), @searchable.case_manager),
                  {
                    # prompt: t('please_select_label'),
                    class: 'ui search dropdown',
                    id: 'case_manager_dropdown'
                  } %>

    </div> 
    <div class="field --bottom">
      <button tyep="submit" class="ui button --submit --md" id="button-submit">
        <i class="icon search"></i>
        <%= t("report.search_label") %>
      </button>
    </div>
  </div>
<% end %>

<script>
  $('form').submit(()=> {
    $('#result_container').html(`<%= render 'reports/loading' %>`);
  });

  $('#case_manager_dropdown').dropdown();

  $('.ui.radio.checkbox').checkbox();

  $('#hospital_destination').dropdown({
    fullTextSearch: true,
    onChange: function(value, text, $selectedItem) {
      onChangeCaseManager(value, "<%= @token %>", 'hospital_destination', '<%= type %>');
    }
  });

  $('#hospital').dropdown({
    fullTextSearch: true,
    onChange: function(value, text, $selectedItem) {
      onChangeCaseManager(value, "<%= @token %>", 'hospital', '<%= type %>');
    }
  });

  $('input[name="htype"]').change((v) => {
    const componentName = '#hospital';
    $('.field.hospital').addClass("disabled")
    $.ajax({
      url: `/hospital/filter?htype=${$('input[name="htype"]:checked').val()}&token=<%= @token %>` 
    }).done(function(data) {
      setOption(data, componentName);
      onChangeCaseManager('all', "<%= @token %>", 'hospital', '<%= type %>');
      $('.field.hospital').removeClass("disabled")
    });
  });

  $('input[name="destination"]').change(() => {
    const destination_checked = $('[name="destination"]:checked').val();
    if(destination_checked === 'site'){
      '<%= type %>' === 'assessment' && onChangeCaseManager('all', "<%= @token %>", 'hospital_destination', '<%= type %>');
      $('#hospital_destination_select').removeClass("disabled")
    }else if(destination_checked === 'accept'){
      $('#hospital_destination').dropdown('set selected', 'all');
      $('#hospital_destination_select').addClass("disabled")
      '<%= type %>' === 'assessment' && onChangeCaseManager($('#hospital').val(), "<%= @token %>", 'hospital', '<%= type %>');
    }
  });

  enableCalendar('#from_date_component', {
    // startMode: 'year',
    endCalendar: $('#to_date_component'),
    maxDate: new Date()
  });

  enableCalendar('#to_date_component', {
    // startMode: 'year',
    startCalendar: $('#from_date_component'),
    maxDate: new Date()
  });
  setDate("<%=@searchable.from_date%>","<%=@searchable.to_date %>");
</script>
